#!/bin/bash
# script d'installation d'une iso Windows pour sambaedu-client-windows
# téléchargement auto de la dernière version de W10 ou W11

# version : 10 ou 11 (on prend toujours la derniere x64)

deploy()
{
	version="Win$1"
	[ -f "/var/sambaedu/unattended/install/os/iso/$2" ] || exit 1
	[ -f /mnt/iso ] || mkdir /mnt/iso
	[ -f /var/sambaedu/unattended/install/os/$version/sources/boot.wim ] && cp /var/sambaedu/unattended/install/os/$version/sources/boot.wim /var/sambaedu/unattended/install/os/boot.wim-$version-old
	mount -o loop,ro  "/var/sambaedu/unattended/install/os/iso/$2" /mnt/iso && rm -rf /var/sambaedu/unattended/install/os/$version
	mkdir -p /var/sambaedu/unattended/install/os/$version/
	cp -R /mnt/iso/* /var/sambaedu/unattended/install/os/$version/
	chown -R www-admin /var/sambaedu/unattended/install/os/$version
	chmod 666 /var/sambaedu/unattended/install/os/$version/sources/boot.wim
	echo "Sources Windows $version installées<br>.
Si votre carte réseau ou le disque ne sont pas reconnus lors de l'installation,
vous devrez injecter les drivers réseau dans l'image de boot avec DISM depuis un poste windows 10 / 11.
Vous pouvez si besoin récuperer les drivers dans le fichier /var/sambaedu/unattended/install/os/boot.wim-$version-old<br>
" 
	umount /mnt/iso
	rm -fr /mnt/iso
	DEBIAN_FRONTEND=noninteractive apt-get install --reinstall sambaedu-client-windows --yes > /dev/null	
}

download(){
	# DL et installation si cela a changé
	rel="Latest"
	pushd .
	[[ -d /var/sambaedu/unattended/install/os/iso ]] || mkdir /var/sambaedu/unattended/install/os/iso
	cd /var/sambaedu/unattended/install/os/iso
	iso=$(pwsh /usr/share/sambaedu/scripts/Fido.ps1 -Arch x64 -Win $1 -Ed Pro -rel "$rel" -Lang Fr -GetUrl | sed "s%^.*/\(.*\.iso\)?t=.*$%\1%")
	if [ -n "$iso" ]; then
		if [ ! -f "$iso" ]; then
			pwsh /usr/share/sambaedu/scripts/Fido.ps1 -Arch x64 -Win $1 -Ed Pro -rel "$rel" -Lang Fr
			if [ $? -eq 0 ]; then
				deploy $1 $iso
			else
				rm -f $iso
				exit 1
			fi
		else
			deploy $1 $iso
		fi 
	fi
	popd
}

# mise en place powershell (eh oui !)
if ! dpkg-query -W --showformat '${binary:Package} ' | grep -q "powershell"; then
	curl https://packages.microsoft.com/keys/microsoft.asc | gpg -o /etc/apt/trusted.gpg.d/microsoft.gpg --dearmor --yes || exit 1
	debian_version=$(cat /etc/os-release | grep "VERSION_CODENAME" | cut -d= -f2)
	echo "deb [arch=amd64] https://packages.microsoft.com/repos/microsoft-debian-${debian_version}-prod ${debian_version} main" > /etc/apt/sources.list.d/microsoft.list
	DEBIAN_FRONTEND=noninteractive apt-get update 
	DEBIAN_FRONTEND=noninteractive apt-get install -y -q powershell
fi

# DL et installation si cela a changé
if [ -z "$1" ]; then
  echo "usage: $0 10|11 [Image.iso]"
  exit 1
fi
if [ -z "$2" ]; then
	download $1
else
	deploy $1 $2
fi
exit $?
